unit flares;

INTERFACE

uses Engine3D;

procedure init;
procedure done;
procedure go;

IMPLEMENTATION

uses main,Anima13,Mode13,math,Op386;

var
	s1,s2:TSprite;
	a,b,
	DecHeight,
	IncLeft,IncRight,
	IncY1:integer;

procedure flare(var s:TSprite);ASSEMBLER;
ASM
	LES			DI,s

	PUSH		BP
	MOV			BX,ES:TSprite[DI].n

	MOV			CX,0
	MOV			DecHeight,CX
	MOV			IncY1,CX
	MOV			IncLeft,CX
	MOV			IncRight,CX

	MOV			SI,WORD(SprInfo)
	MOV			AX,WORD(SprInfo+2)
	DW			MOV_GS_AX
	SHL			BX,3
	ADD			SI,BX

	MOV			DX,region.xul
	MOV			CX,ES:TSprite[DI].x
	MOV			AX,CX
	DB			GS;ADD		 AX,WORD(TSprInfo[SI].width)
	CMP			AX,DX						{if x+ancho<region.xul then goto fin}
	JLE			@SALIR

	CMP			CX,DX   				{if x<region.xul then...}
	JGE			@SIGUE_X1

	MOV			AX,DX           {x:=region.xul;}
	SUB			AX,CX
	MOV			IncLeft,AX     {...dec(ancho,abs(region.xul-x);}

	MOV			CX,DX						{CX=x=region.xul}
	JMP			@SIGUE_X2

@SIGUE_X1:
	MOV			DX,region.xlr
	CMP			CX,DX   				{if x>region.xlr then goto fin}
	JGE			@SALIR

	CMP			AX,DX   				{if x+ancho>region.xlr then...}
	JL			@SIGUE_X2
	SUB			AX,DX
	MOV			IncRight,AX   	{dec(ancho,(x+ancho)-region.xlr}

@SIGUE_X2:
	MOV			DX,region.yul
	MOV			BX,ES:TSprite[DI].y
	MOV			AX,BX
	DB			GS;ADD		AX,WORD(TSprInfo[SI].height)
	CMP			AX,DX						{if y+alto<region.yul then goto fin}
	JLE			@SALIR

	CMP			BX,DX   				{if y<region.yul then...}
	JGE			@SIGUE_Y1
	MOV			AX,DX           {y:=region.yul;}
	SUB			AX,BX
	MOV			DecHeight,AX      {...dec(alto,abs(region.yul-y);}

	DB			GS;MOV		BP,WORD(TSprInfo[SI].width)
	IMUL		BP              {...inc(IncY1,abs(region.yul-y)*ancho);}
	MOV			IncY1,AX
	MOV			BX,region.yul		{...y:=region.yul}

@SIGUE_Y1:
	MOV			DX,region.ylr
	CMP			BX,DX   				{if y>region.ylr then goto fin}
	JGE			@SALIR

	MOV			AX,BX
	DB			GS;ADD		AX,WORD(TSprInfo[SI].height)
	CMP			AX,DX   				{if y+alto>region.ylr then...}
	JL			@SIGUE_Y2
	SUB			AX,DX
	DEC			AX
	MOV			DecHeight,AX  		{dec(alto,(y+alto)-region.ylr}
	JMP			@SIGUE_Y2

@SIGUE_Y2:      {BX=y, CX=x}
	DB			GS;MOV		DX,TSprInfo[SI].height
	SUB			DX,DecHeight
	MOV			DI,CX

	ADD			BX,BX
	ADD			DI,WORD(MultByWidth[BX])

	DB			GS;MOV		BX,TSprInfo[SI].width
	SUB			BX,IncLeft
	SUB			BX,IncRight
	MOV			BP,320
	SUB			BP,BX

	{$IFDEF __BPPROT__}
	MOV			CX,CS
	ADD			CX,SelectorInc
	MOV			ES,CX
	MOV			CX,IncLeft
	ADD			CX,IncRight
	MOV			WORD(ES:@I_LR+2),CX
	{$ELSE}
	MOV			CX,IncLeft
	ADD			CX,IncRight
	MOV			WORD(CS:@I_LR+2),CX
	{$ENDIF}

	MOV			ES,vRAM
	PUSH		DS
	MOV			AX,IncY1
	ADD			AX,IncLeft
	DB			GS;LDS		SI,TSprInfo[SI].PSprite
	ADD			SI,AX
	MOV			AX,BX

@Y:
	MOV			CX,AX

@X:               {ALIGN 16}
	MOV			BL,[SI]
	INC			SI
	TEST		BL,BL
	JZ			@CERO
	MOV			ES:[DI],BL

@CERO:
	INC			DI
	DEC			CX
	JNZ			@X

@I_LR:
	ADD			SI,$FFFF
	ADD			DI,BP
	DEC			DX
	JNZ     @Y

	POP			DS
	POP			BP

@SALIR:
END;

procedure init;
begin
	SetSprite(s1,_FLARE_1_);
	s1.angle:=random(DEG);

	SetSprite(s2,_FLARE_2_);
	s2.angle:=random(DEG);

	a:=10;b:=1;
end;

procedure done;
begin
end;

procedure go;
begin
	s1.x:=80-round(a*cos(s1.angle*RAD));
	s1.y:=50+round(a*2*sin(s1.angle*RAD));
	s1.angle:=s1.angle+1;

	s2.x:=240+round(a*sin(s2.angle*RAD));
	s2.y:=50+round(a*cos(s2.angle*RAD));
	s2.angle:=s2.angle+1.5;

	inc(a,b);
	if (a<1) or (a>100) then b:=-b;
	flare(s1);
	flare(s2);
end;

end.